=== modified file 'client/mysqldump.c'
--- client/mysqldump.c	2008-07-07 12:48:50 +0000
+++ client/mysqldump.c	2008-07-08 18:37:01 +0000
@@ -2340,7 +2340,6 @@
         */
         is_blob= (opt_hex_blob && field->charsetnr == 63 &&
                   (field->type == MYSQL_TYPE_STRING ||
-                   field->type == MYSQL_TYPE_VAR_STRING ||
                    field->type == MYSQL_TYPE_VARCHAR ||
                    field->type == MYSQL_TYPE_BLOB ||
                    field->type == MYSQL_TYPE_LONG_BLOB ||

=== modified file 'sql/field.h'
--- sql/field.h	2008-07-08 16:17:31 +0000
+++ sql/field.h	2008-07-08 18:37:01 +0000
@@ -1372,11 +1372,7 @@
 
   enum_field_types type() const
   {
-    return ((can_alter_field_type && orig_table &&
-             orig_table->s->db_create_options & HA_OPTION_PACK_RECORD &&
-	     field_length >= 4) &&
-            orig_table->s->frm_version < FRM_VER_TRUE_VARCHAR ?
-	    MYSQL_TYPE_VAR_STRING : MYSQL_TYPE_STRING);
+    return  MYSQL_TYPE_STRING;
   }
   enum ha_base_keytype key_type() const
     { return binary() ? HA_KEYTYPE_BINARY : HA_KEYTYPE_TEXT; }

=== modified file 'sql/handler.h'
--- sql/handler.h	2008-07-07 14:25:25 +0000
+++ sql/handler.h	2008-07-08 18:37:01 +0000
@@ -144,7 +144,7 @@
   uses a primary key. Without primary key, we can't call position().
 */ 
 #define HA_PRIMARY_KEY_REQUIRED_FOR_POSITION (1 << 16) 
-#define HA_CAN_RTREEKEYS       (1 << 17)
+#define HA_CAN_RTREEKEYS       (1 << 17) /* Historical, no longer supported */
 #define HA_NOT_DELETE_WITH_CACHE (1 << 18)
 /*
   The following is we need to a primary key to delete (and update) a row.
@@ -152,20 +152,20 @@
 */
 #define HA_PRIMARY_KEY_REQUIRED_FOR_DELETE (1 << 19)
 #define HA_NO_PREFIX_CHAR_KEYS (1 << 20)
-#define HA_CAN_FULLTEXT        (1 << 21)
-#define HA_CAN_SQL_HANDLER     (1 << 22)
+#define HA_CAN_FULLTEXT        (1 << 21) /* Historical, no longer supported */
+#define HA_CAN_SQL_HANDLER     (1 << 22) /* Historical, no longer supported */
 #define HA_NO_AUTO_INCREMENT   (1 << 23)
 #define HA_HAS_CHECKSUM        (1 << 24)
 /* Table data are stored in separate files (for lower_case_table_names) */
 #define HA_FILE_BASED	       (1 << 26)
-#define HA_NO_VARCHAR	       (1 << 27)
-#define HA_CAN_BIT_FIELD       (1 << 28) /* supports bit fields */
+#define HA_NO_VARCHAR	       (1 << 27) /* Historical, no longer supported */
+#define HA_CAN_BIT_FIELD       (1 << 28) /* Historical, no longer supported */
 #define HA_NEED_READ_RANGE_BUFFER (1 << 29) /* for read_multi_range */
 #define HA_ANY_INDEX_MAY_BE_UNIQUE (1 << 30)
 #define HA_NO_COPY_ON_ALTER    (1LL << 31)
 #define HA_HAS_RECORDS	       (1LL << 32) /* records() gives exact count*/
 /* Has it's own method of binlog logging */
-#define HA_HAS_OWN_BINLOGGING  (1LL << 33)
+#define HA_HAS_OWN_BINLOGGING  (1LL << 33) /* Historical, no longer supported */
 #define HA_MRR_CANT_SORT       (1LL << 34)
 
 /*
@@ -343,7 +343,7 @@
 
 /* Bits in used_fields */
 #define HA_CREATE_USED_AUTO             (1L << 0)
-#define HA_CREATE_USED_RAID             (1L << 1) //RAID is no longer availble
+#define HA_CREATE_USED_RAID             (1L << 1) /* Historical, no longer supported */
 #define HA_CREATE_USED_UNION            (1L << 2)
 #define HA_CREATE_USED_INSERT_METHOD    (1L << 3)
 #define HA_CREATE_USED_MIN_ROWS         (1L << 4)

=== modified file 'sql/item_subselect.cc'
--- sql/item_subselect.cc	2008-07-06 19:07:51 +0000
+++ sql/item_subselect.cc	2008-07-08 18:37:01 +0000
@@ -2102,7 +2102,7 @@
   Item *sel_item;
   List_iterator_fast<Item> li(item_list);
   res_type= STRING_RESULT;
-  res_field_type= MYSQL_TYPE_VAR_STRING;
+  res_field_type= MYSQL_TYPE_STRING;
   for (uint i= 0; (sel_item= li++); i++)
   {
     item->max_length= sel_item->max_length;

=== modified file 'sql/item_subselect.h'
--- sql/item_subselect.h	2008-06-25 05:29:13 +0000
+++ sql/item_subselect.h	2008-07-08 18:37:01 +0000
@@ -402,7 +402,7 @@
     result= res;
     item= si;
     res_type= STRING_RESULT;
-    res_field_type= MYSQL_TYPE_VAR_STRING;
+    res_field_type= MYSQL_TYPE_STRING;
     maybe_null= 0;
   }
   virtual ~subselect_engine() {}; // to satisfy compiler

=== modified file 'sql/item_sum.cc'
--- sql/item_sum.cc	2008-07-08 16:17:31 +0000
+++ sql/item_sum.cc	2008-07-08 18:37:01 +0000
@@ -2600,7 +2600,7 @@
       Field *f= *field;
       enum enum_field_types f_type= f->type();
       tree_key_length+= f->pack_length();
-      if ((f_type == MYSQL_TYPE_VARCHAR) || (!f->binary() && (f_type == MYSQL_TYPE_STRING || f_type == MYSQL_TYPE_VAR_STRING)))
+      if ((f_type == MYSQL_TYPE_VARCHAR) || (!f->binary() && (f_type == MYSQL_TYPE_STRING)))
       {
         all_binary= FALSE;
         break;

=== modified file 'sql/log_event.h'
--- sql/log_event.h	2008-07-07 16:41:35 +0000
+++ sql/log_event.h	2008-07-08 18:37:01 +0000
@@ -3141,17 +3141,6 @@
   </tr>
 
   <tr>
-    <td>MYSQL_TYPE_VAR_STRING</td><td>253</td>
-    <td>2 bytes</td>
-    <td>This is used to store both strings and enumeration values.
-    The first byte is a enumeration value storing the <i>real
-    type</i>, which may be either MYSQL_TYPE_VAR_STRING or
-    MYSQL_TYPE_ENUM.  The second byte is a 1 byte unsigned integer
-    representing the field size, i.e., the number of bytes needed to
-    store the length of the string.</td>
-  </tr>
-
-  <tr>
     <td>MYSQL_TYPE_STRING</td><td>254</td>
     <td>2 bytes</td>
     <td>The first byte is always MYSQL_TYPE_VAR_STRING (i.e., 253).

=== modified file 'sql/protocol.cc'
--- sql/protocol.cc	2008-07-07 21:16:22 +0000
+++ sql/protocol.cc	2008-07-08 18:37:01 +0000
@@ -569,10 +569,6 @@
     Send_field field;
     item->make_field(&field);
 
-    /* Keep things compatible for old clients */
-    if (field.type == MYSQL_TYPE_VARCHAR)
-      field.type= MYSQL_TYPE_VAR_STRING;
-
     prot.prepare_for_resend();
 
     if (thd->client_capabilities & CLIENT_PROTOCOL_41)

=== modified file 'sql/sql_table.cc'
--- sql/sql_table.cc	2008-07-08 16:53:50 +0000
+++ sql/sql_table.cc	2008-07-08 18:37:01 +0000
@@ -1714,23 +1714,6 @@
     (*blob_columns)++;
     break;
   case MYSQL_TYPE_VARCHAR:
-#ifndef QQ_ALL_HANDLERS_SUPPORT_VARCHAR
-    if (table_flags & HA_NO_VARCHAR)
-    {
-      /* convert VARCHAR to CHAR because handler is not yet up to date */
-      sql_field->sql_type=    MYSQL_TYPE_VAR_STRING;
-      sql_field->pack_length= calc_pack_length(sql_field->sql_type,
-                                               (uint) sql_field->length);
-      if ((sql_field->length / sql_field->charset->mbmaxlen) >
-          MAX_FIELD_CHARLENGTH)
-      {
-        my_printf_error(ER_TOO_BIG_FIELDLENGTH, ER(ER_TOO_BIG_FIELDLENGTH),
-                        MYF(0), sql_field->field_name, MAX_FIELD_CHARLENGTH);
-        return(1);
-      }
-    }
-#endif
-    /* fall through */
   case MYSQL_TYPE_STRING:
     sql_field->pack_flag=0;
     if (sql_field->charset->state & MY_CS_BINSORT)

